unit fInfo;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ToolWin, ActnMan, ActnCtrls,
  ActnList, StdActns, XPStyleActnCtrls;

type
  TfrmInfo = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    mmInfo: TMemo;
    BitBtn1: TBitBtn;
    ActionManager1: TActionManager;
    FileSaveAs1: TFileSaveAs;
    ActionToolBar1: TActionToolBar;
    BitBtn2: TBitBtn;
    cbReadOnly: TCheckBox;
    cbWW: TCheckBox;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure cbWWClick(Sender: TObject);
    procedure cbReadOnlyClick(Sender: TObject);
    procedure FileSaveAs1Accept(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInfo: TfrmInfo;

function ShowInfo(anInfo: string; aCaption: String = 'Information'): Integer;

implementation

{$R *.dfm}

function ShowInfo(anInfo: string; aCaption: String = 'Information'): Integer;
begin
  if not Assigned(frmInfo) then
    Application.CreateForm(TfrmInfo, frmInfo);
  frmInfo.Caption := aCaption;
  frmInfo.mmInfo.Text := anInfo;
  Result := frmInfo.ShowModal;
end;

procedure TfrmInfo.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = char(VK_ESCAPE) then
    Close;
end;

procedure TfrmInfo.cbWWClick(Sender: TObject);
begin
  mmInfo.WordWrap := cbWW.Checked;
  if cbWW.Checked then
    mmInfo.ScrollBars := ssVertical
  else
    mmInfo.ScrollBars := ssBoth;
end;

procedure TfrmInfo.cbReadOnlyClick(Sender: TObject);
begin
  mmInfo.ReadOnly := cbReadOnly.Checked;
  if mmInfo.ReadOnly then
    mmInfo.Color := clInfoBk
  else
    mmInfo.Color := clCream;
end;

procedure TfrmInfo.FileSaveAs1Accept(Sender: TObject);
begin
  mmInfo.Lines.SaveToFile(FileSaveAs1.Dialog.FileName);
end;

end.
